//Copyright Magnus Hellman 2000

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <OS.h>

int main(int argc, char *argv[])
{
	status_t st;
	sem_info info;
	if (argc == 1) {
		int32 bikkie = 0;
		team_info teamInfo;
		while (get_next_team_info(&bikkie, &teamInfo) == B_OK) {
			printf("Team %d %s\n", teamInfo.team, teamInfo.args);
			int32 bikkie = 0;
			while (get_next_sem_info(teamInfo.team, &bikkie, &info) == B_OK)
				printf(	"%6u: %-32s %u\n", info.sem, info.name, info.count);
			printf("\n");
		}
	} else
	if (argc == 3 && strcmp(argv[1], "-T") == 0) {
		int32 bikkie = 0;
		while ((st = get_next_sem_info(atoi(argv[2]), &bikkie, &info)) == B_OK)
			printf(	"%6u: %-32s %u\n", info.sem, info.name, info.count);
		
		if (st != B_BAD_VALUE)
			printf("get_next_sem_info(%s) error: 0x%x %s\n", argv[1], st, strerror(st));
			
	} else
	if (argc >= 2) {
		for (int i = 1; i < argc; ++i) {
			sem_id sem = atoi(argv[i]);
			st = get_sem_info(sem, &info);
			if (i > 1)
				printf("\n");
			if (st == B_OK) {
				char strCount[100];
				if (info.count < -1)
					sprintf(strCount, "between 1 and %d threads are waiting for this semaphore", -info.count);
				if (info.count == -1)
					strcpy(strCount, "1 thread is waiting for this semaphore");
				else
				if (info.count == 0)
					strcpy(strCount, "the next thread which tries to acquire this semaphore will wait");
				else
				if (info.count == 1)
					strcpy(strCount, "this semaphore can be acquired once without waiting");
				else
					sprintf(strCount, "this semaphore can be acquired %d times without waiting", info.count);
				
				char strLatestHolder[100];
				thread_info threadInfo;
				if (get_thread_info(info.latest_holder, &threadInfo) == B_OK) {
					char strTeam[65];
					team_info teamInfo;
					if (get_team_info(threadInfo.team, &teamInfo) == B_OK) {
						int lastSlash = 0;
						int len = strlen(teamInfo.args);
						for (int i = 0; i < len; ++i)
							if (teamInfo.args[i] == '/')
								lastSlash = i + 1;
						strncpy(strTeam, teamInfo.args + lastSlash, 64);
					} else
						strcpy(strTeam, "<invalid team id>");
					sprintf(strLatestHolder, "team %u: %s", threadInfo.team, strTeam);
				} else
					strcpy(strLatestHolder, "invalid thread id");
				
				printf(	"Semaphore id:  %s\n"
						"Team id:       %u\n"
						"Name:          %s\n"
						"Count:         %d (%s)\n"
						"Latest holder: %u (%s)\n",
					argv[i], info.team, info.name, info.count, strCount,
					info.latest_holder, strLatestHolder);
				
				if (info.count < 0) {
					int32 biscuit = 0;
					team_info teamInfo;
					while (get_next_team_info(&biscuit, &teamInfo) == B_OK) {
						int32 biscuit = 0;
						thread_info threadInfo;
						while (get_next_thread_info(teamInfo.team, &biscuit, &threadInfo) == B_OK)
							if (threadInfo.sem == sem)
								printf("Thread %u (%s in team %u) is waiting for this semaphore\n",
											threadInfo.thread, threadInfo.name, teamInfo.team);
					}
				}
			} else
				printf("get_sem_info(%s) error: 0x%x %s\n", argv[i], st, strerror(st));
		}
	} else
		printf("Usage: seminfo <sem_id> ...\n");

	return 0;
}
