//Copyright Magnus Hellman 2000

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <OS.h>

int main(int argc, char *argv[])
{
	int32 biscuit = 0;
	status_t st;
	team_info info;
	
	if (argc == 1) {
		while ((st = get_next_team_info(&biscuit, &info)) == B_OK) {
			char args[65]; //I don't know if this is 0-terminated if arg length is >= 64
			memcpy(args, info.args, 64);
			args[64] = 0;
			printf("%5u: %s\n", info.team, args);
		}
		
		if (st != B_BAD_VALUE)
			printf("get_next_team_info error: 0x%x %s\n", st, strerror(st));
	} else
	if (argc >= 2) {
		for (int i = 1; i < argc; ++i) {
			st = get_team_info(atoi(argv[i]), &info);
			if (i > 1)
				printf("\n");
			if (st == B_OK) {
				char args[65];
				memcpy(args, info.args, 64);
				args[64] = 0;
				printf(	"Team id:      %u\n"
						"Thread count: %u\n"
						"Image count:  %u\n"
						"Area count:   %u\n"
						"Arg count:    %u (including program name)\n"
						"Command line: %s\n"
						"User id:      %u\n"
						"Group id:     %u\n",
					info.team, info.thread_count, info.image_count, info.area_count,
					info.argc, args, info.uid, info.gid);
			} else
				printf("get_team_info(%s) error: 0x%x %s\n", argv[i], st, strerror(st));
		}
	} else
		printf("Usage: teaminfo [team_id ...]\n");

	return 0;
}
